package com.restlet.client.async;

import com.restlet.client.utils.Nullable;

/**
 * Promise handler
 *
 * @param <T> type of input parameter
 */
public interface PromiseHandler<T> {
    /**
     * Handles promise result. If any exception is thrown during execution,
     * it will pushed down the promise chain
     *
     * @param param param to handle
     * @return object or promise to be pushed down the promise chain
     */
    Object on(@Nullable T param);
}
