package com.restlet.client.log.impl;

import com.restlet.client.function.Executor;
import com.restlet.client.log.LogService;

public class MockLogService implements LogService {

    private final Class<?> clazz;
    private final Executor callBack;

    public MockLogService(final Class<?> clazz) {
        this.clazz = clazz;
        this.callBack = new Executor() {
            @Override
            public void execute() {
                // Do nothing
            }
        };
    }

    public MockLogService(final Class<?> clazz, final Executor callBack) {
        this.clazz = clazz;
        this.callBack = callBack;
    }

    @Override
    public void debug(final Class<?> clazz, final String message) {
        this.callBack.execute();
    }

    @Override
    public void debug(final Class<?> clazz, final String message, final Throwable e) {
        this.callBack.execute();
    }

    @Override
    public void fine(final Class<?> clazz, final String message) {
        this.callBack.execute();
    }

    @Override
    public void error(final String message) {
        this.callBack.execute();
    }

    @Override
    public void error(final String message, final Throwable e) {
        this.callBack.execute();
    }

    @Override
    public void info(final String message) {
        this.callBack.execute();
    }

    @Override
    public void warning(final String message) {
        this.callBack.execute();
    }

    @Override
    public void log(final Severity severity, final String message) {
        severity.log(this, message, clazz);
    }
}
