package com.restlet.client.model.impl;

import com.restlet.client.model.EntityTo;

import java.io.Serializable;

public class EntityToImpl implements EntityTo, Serializable {

    private static final long serialVersionUID = -3538476612138864748L;

    private Type type;
    private String name;
    private String description;
    private Integer descriptionHeight;
    private Boolean descriptionCollapsed;
    private String id;
    private String lastModified;
    private boolean isShared;
    private boolean isLocked;
    private EntityTo parent;
    private String remoteModification;
    private boolean isModifiedLocally;
    private String remoteId;

    @Override
    public Type getType() {
        return type;
    }

    @Override
    public void setType(final Type type) {
        this.type = type;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(final String name) {
        this.name = name;
    }

    @Override
    public String getDescription() {
        return description;
    }

    @Override
    public void setDescription(final String description) {
        this.description = description;
    }

    @Override
    public Integer getDescriptionHeight() {
        return descriptionHeight;
    }

    @Override
    public void setDescriptionHeight(final Integer descriptionHeight) {
        this.descriptionHeight = descriptionHeight;
    }

    @Override
    public Boolean getDescriptionCollapsed() {
        return descriptionCollapsed;
    }

    @Override
    public void setDescriptionCollapsed(final Boolean descriptionCollapsed) {
        this.descriptionCollapsed = descriptionCollapsed;
    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public void setId(final String id) {
        this.id = id;
    }

    @Override
    public String getLastModified() {
        return lastModified;
    }

    @Override
    public void setLastModified(final String lastModified) {
        this.lastModified = lastModified;
    }

    @Override
    public EntityTo getParent() {
        return parent;
    }

    @Override
    public void setParent(final EntityTo parent) {
        this.parent = parent;
    }

    @Override
    public boolean isShared() {
        return isShared;
    }

    @Override
    public void setShared(final boolean shared) {
        this.isShared = shared;
    }

    @Override
    public boolean isLocked() {
        return isLocked;
    }

    @Override
    public void setLocked(final boolean isLocked) {
        this.isLocked = isLocked;
    }

    @Override
    public String getRemoteModification() {
        return remoteModification;
    }

    @Override
    public void setRemoteModification(final String token) {
        this.remoteModification = token;
    }

    @Override
    public boolean isModifiedLocally() {
        return isModifiedLocally;
    }

    @Override
    public void setModifiedLocally(final boolean modified) {
        this.isModifiedLocally = modified;
    }

    @Override
    public String getRemoteId() {
        return remoteId;
    }

    @Override
    public void setRemoteId(final String remoteId) {
        this.remoteId = remoteId;
    }

    @Override
    public boolean equals(final Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        final EntityToImpl entityTo = (EntityToImpl) o;

        if (isShared != entityTo.isShared) return false;
        if (isModifiedLocally != entityTo.isModifiedLocally) return false;
        if (type != entityTo.type) return false;
        if (name != null ? !name.equals(entityTo.name) : entityTo.name != null) return false;
        if (description != null ? !description.equals(entityTo.description) : entityTo.description != null)
            return false;
        if (descriptionHeight != null ? !descriptionHeight.equals(entityTo.descriptionHeight) : entityTo.descriptionHeight != null)
            return false;
        if (descriptionCollapsed != null ? !descriptionCollapsed.equals(entityTo.descriptionCollapsed) : entityTo.descriptionCollapsed != null)
            return false;
        if (id != null ? !id.equals(entityTo.id) : entityTo.id != null) return false;
        if (lastModified != null ? !lastModified.equals(entityTo.lastModified) : entityTo.lastModified != null)
            return false;
        if (parent != null ? !parent.equals(entityTo.parent) : entityTo.parent != null) return false;
        return remoteModification != null ? remoteModification.equals(entityTo.remoteModification) : entityTo.remoteModification == null;

    }

    @Override
    public int hashCode() {
        int result = type != null ? type.hashCode() : 0;
        result = 31 * result + (name != null ? name.hashCode() : 0);
        result = 31 * result + (description != null ? description.hashCode() : 0);
        result = 31 * result + (descriptionHeight != null ? descriptionHeight.hashCode() : 0);
        result = 31 * result + (descriptionCollapsed != null ? descriptionCollapsed.hashCode() : 0);
        result = 31 * result + (id != null ? id.hashCode() : 0);
        result = 31 * result + (lastModified != null ? lastModified.hashCode() : 0);
        result = 31 * result + (isShared ? 1 : 0);
        result = 31 * result + (parent != null && parent.getId() != null ? parent.getId().hashCode() : 0);
        result = 31 * result + (remoteModification != null ? remoteModification.hashCode() : 0);
        result = 31 * result + (isModifiedLocally ? 1 : 0);
        return result;
    }

    @Override
    public String toString() {
        return "EntityToImpl{" +
                "type=" + type +
                ", name='" + name + '\'' +
                ", description='" + description + '\'' +
                ", descriptionHeight=" + descriptionHeight +
                ", descriptionCollapsed=" + descriptionCollapsed +
                ", id='" + id + '\'' +
                ", lastModified='" + lastModified + '\'' +
                ", shared=" + isShared +
                ", parent=" + parent +
                ", remoteModification='" + remoteModification + '\'' +
                ", isModifiedLocally=" + isModifiedLocally +
                '}';
    }
}
