package com.restlet.client.net.http.request.impl;

import com.restlet.client.net.http.request.HttpMethodDefinition;

import java.io.Serializable;

public class HttpMethodDefinitionImpl implements HttpMethodDefinition, Serializable {

    private static final long serialVersionUID = -6703915649376251158L;

    private String name;
    private boolean isCustom;
    private boolean isRequestBody;
    private String link;

    public HttpMethodDefinitionImpl() {
    }

    public HttpMethodDefinitionImpl(String name, boolean isCustom, boolean isRequestBody, String link) {
        this.name = name;
        this.isCustom = isCustom;
        this.isRequestBody = isRequestBody;
        this.link = link;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(String name) {
        this.name = name;
    }

    @Override
    public boolean isCustom() {
        return isCustom;
    }

    @Override
    public void setCustom(boolean custom) {
        this.isCustom = custom;
    }

    @Override
    public boolean isRequestBody() {
        return isRequestBody;
    }

    @Override
    public void setRequestBody(boolean requestBody) {
        this.isRequestBody = requestBody;
    }

    @Override
    public String getLink() {
        return link;
    }

    @Override
    public void setLink(String link) {
        this.link = link;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        HttpMethodDefinitionImpl that = (HttpMethodDefinitionImpl) o;

        if (isCustom != that.isCustom) return false;
        if (isRequestBody != that.isRequestBody) return false;
        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        return link != null ? link.equals(that.link) : that.link == null;

    }

    @Override
    public int hashCode() {
        int result = name != null ? name.hashCode() : 0;
        result = 31 * result + (isCustom ? 1 : 0);
        result = 31 * result + (isRequestBody ? 1 : 0);
        result = 31 * result + (link != null ? link.hashCode() : 0);
        return result;
    }
}
