package com.restlet.client.net.request.impl;

import com.restlet.client.net.request.RequestHeaderTo;

import java.io.Serializable;

public class RequestHeaderToImpl implements RequestHeaderTo, Cloneable, Serializable {

    private static final long serialVersionUID = 985134592588195165L;

    private boolean enabled;
    private boolean _default;
    private boolean virtual;
    private String name;
    private String value;

    public RequestHeaderToImpl() {

    }

    public RequestHeaderToImpl(final String string, final String string2) {
        this.enabled = true;
        this.name = string;
        this.value = string2;
    }

    @Override
    public boolean isEnabled() {
        return enabled;
    }

    @Override
    public void setEnabled(final boolean enabled) {
        this.enabled = enabled;
    }

    @Override
    public boolean isVirtual() {
        return virtual;
    }

    @Override
    public void setVirtual(final boolean virtual) {
        this.virtual = virtual;
    }

    @Override
    public RequestHeaderTo clone() {
        final RequestHeaderToImpl clone = new RequestHeaderToImpl();
        clone.enabled = enabled;
        clone._default = _default;
        clone.name = name;
        clone.virtual = virtual;
        clone.value = value;
        return clone;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public void setName(final String name) {
        this.name = name;
    }

    @Override
    public String getValue() {
        return value;
    }

    @Override
    public void setValue(final String value) {
        this.value = value;
    }

    @Override
    public boolean isDefault() {
        return _default;
    }

    @Override
    public void setDefault(final boolean dynamic) {
        this._default = dynamic;
    }
}
