package com.restlet.client.platform;


public interface CryptoApi {

    String hash(HashType hashType, String message, Output out);

    String hmac(HashType hashType, String secret, String message, Output out);

    String md5(String message);

    String decrypt(CipherType type, String message, String secret);

    String encrypt(CipherType type, String message, String secret);

    enum HashType {SHA1("SHA-1"), SHA224("SHA-224"), SHA256("SHA-256"), SHA384("SHA-384"), SHA512("SHA-512");

        public String algorithm;

        HashType(String algorithm) {
            this.algorithm = algorithm;
        }
    }

    enum CipherType {AES}

    enum Output {Base64("B64"), Hex("HEX");

        public String label;

        Output(String label) {
            this.label = label;
        }
    }
}
