package com.restlet.client.script.method;

import com.restlet.client.async.Promise;
import com.restlet.client.async.Promises;
import com.restlet.client.platform.UUIDGenerator;
import com.restlet.client.platform.json.JsonEngine;
import com.restlet.client.script.runtime.ScriptMethod;
import com.restlet.client.script.runtime.ScriptValue;
import com.restlet.client.script.value.ScriptStringValue;

import java.util.List;

public class UUIDGeneratorMethod implements ScriptMethod {

    final JsonEngine jsonEngine;

    public UUIDGeneratorMethod(JsonEngine jsonEngine) {
        this.jsonEngine = jsonEngine;
    }

    @Override
    public String getName() {
        return "uuid";
    }

    @Override
    public Promise<ScriptValue> execute(ScriptValue value, List<ScriptValue> args) {
        return Promises.of((ScriptValue) new ScriptStringValue(UUIDGenerator.uuid(), jsonEngine));
    }

}
