package com.restlet.client.tests;

import com.restlet.client.net.http.HttpClientResultTo;
import com.restlet.client.net.http.request.HttpRequestTo;
import com.restlet.client.tests.asserts.AssertionResultTo;

import java.util.List;

public interface TestResult {

    State getState();

    void setState(State state);

    String getMessage();

    void setMessage(String message);

    HttpRequestTo getHttpRequest();

    HttpClientResultTo getHttpResult();

    void setHttpResult(HttpClientResultTo httpResult);

    List<AssertionResultTo> getAssertionsResult();

    void setAssertionResults(List<AssertionResultTo> results);

    Throwable getThrowable();

    void setThrowable(Throwable throwable);

    boolean isDynamicRequest();

    void setDynamicRequest(boolean dynamicRequest);

    boolean isLocalRequest();

    void setLocalRequest(boolean localRequest);

    enum State {
        Aborted(true, false),
        InProgress(false, false),
        Error(true, true),
        Failure(true, true),
        Ok(true, true),
        None(false, false),
        Skipped(true, false);

        public final boolean terminal;
        public final boolean wasSent;

        State(boolean terminal, boolean wasSent) {
            this.terminal = terminal;
            this.wasSent = wasSent;
        }
    }
}
