package com.restlet.client.utils;

import com.restlet.client.async.Deferred;
import com.restlet.client.async.Promise;
import com.restlet.client.async.Promises;
import com.restlet.client.async.impl.DeferredImpl;
import com.restlet.client.platform.blob.Blob;
import com.restlet.client.platform.blob.BlobReader;

public class BlobUtils {

    public static Promise<String> read(BlobReader reader, Blob blob) {
        if (blob == null || blob.isEmpty()) {
            return Promises.of();
        }
        final Deferred<String> deferred = new DeferredImpl<>();
        reader.readAsText(blob, new BlobReader.Handler<String>() {

            @Override
            public void onLoaded(String text) {
                deferred.resolve(text);
            }

            @Override
            public void onError(Object o) {
                deferred.reject(new RuntimeException(o.toString()));
            }
        });

        return deferred.promise();
    }
}
