package com.restlet.client.utils;

import com.restlet.client.function.Consumer;

public class Holder<T> {

    public T value;

    private Holder(T value) {
        this.value = value;
    }

    public static <T> Holder<T> empty() {
        return new Holder<>(null);
    }

    public static <T> Holder<T> of(T value) {
        return new Holder<>(value);
    }

    public boolean hasValue() {
        return value != null;
    }

    public boolean isEmpty() {
        return !hasValue();
    }

    public Holder<T> ifPresent(Consumer<T> consumer) {
        if (hasValue()) {
            consumer.consume(value);
        }

        return this;
    }

    public Holder<T> clear() {
        value = null;
        return this;
    }

}
