package com.restlet.client.utils;

import java.util.HashMap;
import java.util.Map;

public class MapBuilder<K, V> {

    private final Map<K, V> local = new HashMap<>();

    private MapBuilder() {
    }

    public static <K, V> MapBuilder<K, V> builder() {
        return new MapBuilder<>();
    }

    public MapBuilder<K, V> put(K key, V value) {
        local.put(key, value);
        return this;
    }

    public MapBuilder<K, V> putAll(Map<? extends K, ? extends V> map) {
        local.putAll(map);
        return this;
    }

    public Map<K, V> build() {
        return local;
    }

}
